Dim WShell, FSO, FileData, iCount, sBuffer, iLines, bComment, bAddline, bBlockLine, sCleanedLine
Dim sCvarString, a_sBreak, sCvarName, sCVarDescr, sFullDescr, iCVarCnt, oIE, i

Set WShell = CreateObject("WScript.Shell")
Set FSO = CreateObject("Scripting.FileSystemObject")
FileData = FSO.GetFile(wscript.arguments.item(0))
Set FileInfo = FSO.GetFile(FileData)

' Obtain DATA PATH of file dropped
FilePath = (FileData)
bComment = false
If FSO.FileExists(FilePath) = false then ' Verify file exist
	wscript.quit
end if

iCount = 0
iLines = 0
iCVarCnt = 0
iPlayerCmdCnt = 0
iAdminCmdCnt = 0

Set f = FSO.OpenTextFile(FilePath)
Do Until f.AtEndOfStream
	bAddline = false
	bBlockLine = false
	sBuffer = Trim(f.ReadLine)
	sCleanedLine = replace(sBuffer, "	","")
	iLines = iLines + 1
	
	if bComment = false then	'not in comment from previous line
		if (InStr(sCleanedLine, "/*") <> 0) then	'if comment started
			if (InStr(sCleanedLine, "*/") = 0) then	'if not ended
				bComment = true	'comment continues to next line
			else	'comment ends within line - check if entire line
				if (InStr(sCleanedLine, "/*") = 1) and (InStr(sCleanedLine, "*/") = len(sCleanedLine) - 1) then	'if multiline comment at start and end, whole line is comment
					bBlockLine = true
				end if
			end if
		end if
	else	'in comment from previous line
		if InStr(sCleanedLine, "*/") <> 0 then	'if ended within this line
			if InStr(sCleanedLine, "*/") <> (len(sCleanedLine) - 1) then	'if entire line isnt part of comment - Note: this doesnt account for if remainder of line is { or }
				bAddline = true	'some code exists - add line
			else
				bBlockLine = true	'whole line is comment
			end if
			bComment = false	'comment has been exited
		else
			bBlockLine = true	'whole line is comment
		end if
	end if
	
	if left(sCleanedLine, 2) = "//" then
		bBlockLine = true	'whole line is comment
		bAddline = false
	end if

	if (bBlockLine = false) then	'if entire line is not commented
		if (InStr(sCleanedLine, "CreateConVar") > 0) then	'if cvar
			'ConVar CreateConVar(const char[] name, const char[] defaultValue, const char[] description, int flags, bool hasMin, float min, bool hasMax, float max)
			'convert all dbl quotes to another symbol, replace all remaining single quotes with a new dilimiter, then convert dbl quotes back - now it is safe to split on what was the single quote delimiter
			
			'need to account for constants, like PLUGIN_VERSION not splitting
			sCvarString = right(sCleanedLine, len(sCleanedLine) - InStr(sCleanedLine, "CreateConVar") + 1)
			sBuffer = replace(sBuffer, "\""", "{{{{{")	'replace backslash sgl quote with {{{{{
			a_sBreak = Split(sBuffer, """")	'split by single quote
			'for each sBuffer in a_sBreak	'debug
				'need to clean if description field
				'msgbox(sBuffer)
			'next
			
			'debug
			' sDebugLine = vbnullstring
			' for i = 0 to ubound(a_sBreak)
				' if i = 0 then
					' sDebugLine = a_sBreak(i)
				' else
					' sDebugLine = sDebugLine & " ; " & a_sBreak(i)
				' end if
			' next
			' 'debug
			' if sFullDebugMsg = vbnullstring then
				' sFullDebugMsg = sDebugLine
			' else
				' sFullDebugMsg = sFullDebugMsg & vbnewline & vbnewline & sDebugLine
			' end if
			
			sCvarName = a_sBreak(1)
			
			'need to process cvartest.sp to build how to properly find the description in each case, or know when no description available.
			'see file: cvar params test.xlsx
			sDefaultVal = vbnullstring
			sCVarDescr = vbnullstring
			if Trim(a_sBreak(2)) = "," then
				if ubound(a_sBreak) >= 3 then
					sDefaultVal = replace(Trim(a_sBreak(3)), "{{{{{", """")
				end if
				if ubound(a_sBreak) >= 5 then
					sCVarDescr = replace(Trim(a_sBreak(5)), "{{{{{", """")
				end if
			else
				sDefaultVal = replace(Trim(a_sBreak(2)), "{{{{{", """")
				if ubound(a_sBreak) >= 3 then
					sCVarDescr = replace(Trim(a_sBreak(3)), "{{{{{", """")
				end if
			end if
			
			sFullDescr = sCvarName
			do while len(sFullDescr) < 4*8
				sFullDescr = sFullDescr & " "
			loop
			if sCVarDescr <> vbnullstring then
				sFullDescr = sFullDescr & " -    " & sCVarDescr
			else
				sFullDescr = sFullDescr & " -    [No Description Provided]"
			end if
			sFullDescr = "			<li>" & sFullDescr & "</li>"
			
			if sFullCvarMsg = vbnullstring then
				sFullCvarMsg = sFullDescr
			else
				sFullCvarMsg = sFullCvarMsg & vbnewline & sFullDescr
			end if
			iCVarCnt = iCVarCnt + 1
			
		elseif (InStr(sCleanedLine, "RegConsoleCmd") > 0) then	'if player cmd
			'RegConsoleCmd(const char[] cmd, ConCmd callback, const char[] description, int flags)
			'	RegConsoleCmd("sm_tags", Command_Tag, "Opens TOGs Chat Tags Menu.");
			sBuffer = sCleanedLine
			sBuffer = replace(sBuffer, """);", "")
			sBuffer = replace(sBuffer, "RegConsoleCmd(""", "")
			'	sm_tags", Command_Tag, "Opens TOGs Chat Tags Menu.
			'	0			1				2
			a_sBreak = Split(sBuffer, """")
			sCmd = a_sBreak(0)
			sCmdDescr = vbnullstring
			if ubound(a_sBreak) = 2 then
				sCmdDescr = a_sBreak(2)
			elseif ubound(a_sBreak) > 2 then
				'	sm_tags", Command_Tag, "Opens \"TOGs Chat Tags\" Menu.
				'	0			1			  2           3           4
				sCmdDescr = a_sBreak(2)
				for i = 3 to ubound(a_sBreak)
					sCmdDescr = sCmdDescr & """" & a_sBreak(i)
				next
			end if
			sCmdDescr = replace(sCmdDescr, "\""", """")
			
			sFullDescr = sCmd
			do while len(sFullDescr) < 4*8
				sFullDescr = sFullDescr & " "
			loop
			if sCmdDescr <> vbnullstring then
				sFullDescr = sFullDescr & " -    " & sCmdDescr
			else
				sFullDescr = sFullDescr & " -    [No Description Provided]"
			end if
			sFullDescr = "			<li>" & sFullDescr & "</li>"
			
			if sFullPCmdMsg = vbnullstring then
				sFullPCmdMsg = sFullDescr
			else
				sFullPCmdMsg = sFullPCmdMsg & vbnewline & sFullDescr
			end if
			iPlayerCmdCnt = iPlayerCmdCnt + 1
		
		elseif (InStr(sCleanedLine, "RegAdminCmd") > 0) then	'if admin cmd
			'RegAdminCmd(const char[] cmd, ConCmd callback, int adminflags, const char[] description, const char[] group, int flags)
			'	RegAdminCmd("sm_stopbattle", Command_Stop, ADMFLAG_BAN, "Stops no-scope battles for current round.");
			sBuffer = sCleanedLine
			sBuffer = replace(sBuffer, """);", "")
			sBuffer = replace(sBuffer, "RegAdminCmd(""", "")
			'	sm_stopbattle", Command_Stop, ADMFLAG_BAN, "Stops no-scope battles for current round.
			'		0						1							2
			a_sBreak = Split(sBuffer, """")
			sCmd = a_sBreak(0)
			sCmdDescr = vbnullstring
			if ubound(a_sBreak) = 2 then
				sCmdDescr = a_sBreak(2)
			elseif ubound(a_sBreak) > 2 then
				'	sm_tags", Command_Tag, "Opens \"TOGs Chat Tags\" Menu.
				'	0			1			  2           3           4
				sCmdDescr = a_sBreak(2)
				for i = 3 to ubound(a_sBreak)
					sCmdDescr = sCmdDescr & """" & a_sBreak(i)
				next
			end if
			sCmdDescr = replace(sCmdDescr, "\""", """")
				
			
			sFullDescr = sCmd
			do while len(sFullDescr) < 4*8
				sFullDescr = sFullDescr & " "
			loop
			if sCmdDescr <> vbnullstring then
				sFullDescr = sFullDescr & " -    " & sCmdDescr
			else
				sFullDescr = sFullDescr & " -    [No Description Provided]"
			end if
			sFullDescr = "			<li>" & sFullDescr & "</li>"
			
			if sFullACmdMsg = vbnullstring then
				sFullACmdMsg = sFullDescr
			else
				sFullACmdMsg = sFullACmdMsg & vbnewline & sFullDescr
			end if
			iAdminCmdCnt = iAdminCmdCnt + 1
		end if
	End if

	if (sCleanedLine <> vbNullString) and (sCleanedLine <> "{") and (sCleanedLine <> "}") and (left(sCleanedLine, 2) <> "//") and ( (bAddline=true) or ((bComment = false) and (bBlockLine=false)) ) then
		iCount = iCount + 1
	end if
Loop

f.Close

sFullCliboardMsg = vbnullstring
if sFullCvarMsg <> vbnullstring then
	sFullCliboardMsg = "<div class=""spoiler"">"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "	<input type=""button"" onclick=""showSpoiler(this);"" value=""CVars"" />"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "	<div class=""inner"" style=""display:none;"">"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "		<ul>"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & sFullCvarMsg
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "		</ul>"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "	</div>"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "</div>"
end if

if sFullPCmdMsg <> vbnullstring then 
	if sFullCliboardMsg <> vbnullstring then
		sFullCliboardMsg = sFullCliboardMsg & vbnewline & vbnewline
	end if
	sFullCliboardMsg = sFullCliboardMsg & "<div class=""spoiler"">"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "	<input type=""button"" onclick=""showSpoiler(this);"" value=""Player Cmds"" />"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "	<div class=""inner"" style=""display:none;"">"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "		<ul>"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & sFullPCmdMsg
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "		</ul>"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "	</div>"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "</div>"
end if

if sFullACmdMsg <> vbnullstring then 
	if sFullCliboardMsg <> vbnullstring then
		sFullCliboardMsg = sFullCliboardMsg & vbnewline & vbnewline
	end if
	sFullCliboardMsg = sFullCliboardMsg & "<div class=""spoiler"">"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "	<input type=""button"" onclick=""showSpoiler(this);"" value=""Admin Cmds"" />"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "	<div class=""inner"" style=""display:none;"">"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "		<ul>"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & sFullACmdMsg
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "		</ul>"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "	</div>"
	sFullCliboardMsg = sFullCliboardMsg & vbnewline & "</div>"
end if

'msgbox "Click 'Allow Access' on the prompt that opened up (might be hiding behind other windows)"
'The above warning can be avoided by going into internet explorer options, security tab, custom level, scripting group, "Allow programmatic clipboard access"
Set objIE = CreateObject("InternetExplorer.Application")
objIE.Navigate("about:blank")
objIE.document.parentwindow.clipboardData.SetData "text", sFullCliboardMsg
objIE.Quit

sMsg = "Content copied to clipboard!" 
sMsg = sMsg & vbnewline & "Code Lines: " & iCount & vbNewLine & "File Lines: " & iLines & vbNewLine & "CVar Count: " & iCVarCnt & vbNewLine & "Player Cmd Count: " & iPlayerCmdCnt & vbNewLine & "Admin Cmd Count: " & iAdminCmdCnt
msgbox sMsg

wscript.quit